<?php

class tickets_controllers_searchform extends common_controller
{

public function  index($pars = '')
{
    if(!$this->parser->getUserId())  return '';

    $query = (isset($_GET['query'])) ? $_GET['query'] : '';
    if(trim($query)) $this->search(trim($_GET['query']));

    $this->parser->addCSS(SYS_BASE_URL.'main/styles/jquery-ui.css');
    $this->parser->addScript(SYS_BASE_URL."libs/js/jquery.js");
    $this->parser->addScript(SYS_BASE_URL."libs/js/jqueryui.js");
    $this->parser->addCSS(SYS_BASE_URL."libs/js/autocomplete/styles.css");
    $this->parser->addScript(SYS_BASE_URL."libs/js/autocomplete/jquery.autocomplete-min.js");
    $this->parser->addScript("<script type='text/javascript'>
    $(document).ready(function(){
    var a = $('#idsearchkeywords').autocomplete({
        serviceUrl:'".$this->parser->makeUrl('tickets/searchform')."',
        minChars:1,
        delimiter: /(,|;)\s*/,
        maxHeight:400,
        width:400,
        zIndex: 9999,
        deferRequestBy: 0,
        noCache: true,
        onSelect: function(value, data){ $('#showticketid').val(data);$('#idticketsearchform').submit(); }
      });

    });
    </script>");

    $this->render();
}

public function  search($query = '')
{
    $u = $this->parser->utils->getUserInfo();

    $suggestions = array();

    $qstr = '';
    if(is_numeric($query))
    {
        $qstr = 'p.id='.$query;
    } else
    {
        $ar = explode(' ', trim($query));
        for($i = 0; $i < sizeof($ar); $i++)
        {
            if(!trim($ar[$i]))	continue;
            if($qstr) $qstr .= ' AND ';
            $qstr .= " ((".$this->parser->utils->searchWord("p.title", $ar[$i]).")";
            $qstr .= " OR (".$this->parser->utils->searchWord("p.notes", $ar[$i]).")";
            $qstr .= " OR (".$this->parser->utils->searchWord("p.description", $ar[$i])."))";
        }
    }
    $cond = '';
    if(!$u['super']) $cond .= " AND ((p.isprivate=0) OR (p.creatby='".$u['id'].
              "') OR (p.creatto='".$u['id'].
              "') OR (c.ref3='".$u['id'].
              "') OR (p.monitoring='".$u['id'].
              "') OR ((p.creatby<>'".$u['id']."')
              AND (c.ref1 IN(".$u['subdepartments']."))
              AND (c.ref2 IN(".$u['subpositions']."))))";

    $sql = "SELECT p.id, p.title, c.name_".$this->parser->lang_suff."
            FROM wtk_tickets p, sys_objects c
            WHERE (".$qstr.")
            AND (p.creatby=c.objid)
            AND (p.id > 0)
            ".$cond."
            ORDER BY p.id DESC, p.title";
    //$this->parser->toFile($sql);
    $rs = $this->parser->conn->SelectLimit($sql, 25);
    $suggestions = array();
    $data = array();
    while($row = $rs->FetchRow())
    {
        $data[] = $row[0];
        $suggestions[] = $row[0].' '.mb_substr($row[2], 0, 6, $this->parser->config['charset']).' - '.$row[1];
    }

   	if(ob_get_length()) ob_clean();
    print(json_encode(array("query" => $query, "suggestions" => $suggestions, "data" => $data)));
    exit;
}

}

?>