<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wtk_rights_tickets');
    if(!$perm['r']) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/wcatalog.class.php');
    class wtablecard extends wCatalog
    {
        public $perm = array('c' => 0, 'r' => 0, 'u' => 0, 'd' => 0);
        public function _titleframe()
        {
            global $parser;
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : 0;
            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : '';
            $this->addHidden('parent', $parent);
            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
            $projectid = (isset($_REQUEST['projectid'])) ? $_REQUEST['projectid'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';

            $this->addHidden('callbackfunc', $callbackfunc);
            $this->addHidden('projectid', $projectid);
            $this->addHidden('mastertype', $mastertype);
            $this->addHidden('masterid', $masterid);
            $this->f = new tickets_models_ticket();
            $this->title = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wtk_tickets'", '');

            $this->addMenu(0, $parser->gt('card'), !$active_tab);
            $this->addMenu(1, $parser->gt('ncomments'), ($active_tab == 1));
            $this->addMenu(2, $parser->gt('files'), ($active_tab == 2));


            $more = array();
            $more[] = array(11, $parser->gt('subtickets'));
            $more[] = array(17, $parser->gt('log'));

            $this->addMenu(5, $parser->gt('andmore').'...', ($active_tab == 3), $more);

            $this->extra_from = '';
            $userid = $parser->getUserId();
            if($userid !== 'sys_superadmin')
            {
                $this->extra_from = ', sys_objects u';
                $this->extra_where = " AND (A.creatby=u.objid) AND ((A.isprivate=0)
                                        OR
                                            (A.creatby='".$userid."')
                                             OR (A.creatto='".$userid."')
                                              OR (A.monitoring='".$userid."')
                                               OR (u.ref3='".$userid."')
                                        ) ";
            }
        }

        public function _content()
        {
            global $parser;
            $cat_id = (isset($_REQUEST['cat_id'])) ? $_REQUEST['cat_id'] : '';
            $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : '';
            $parent = (isset($_REQUEST['parent'])) ? $_REQUEST['parent'] : '';
            $active_tab = (isset($_REQUEST['active_tab'])) ? $_REQUEST['active_tab'] : '';
            $callbackfunc = (isset($_REQUEST['callbackfunc'])) ? $_REQUEST['callbackfunc'] : '';
            $card_onload_par = (isset($_REQUEST['card_onload_par'])) ? $_REQUEST['card_onload_par'] : '';
            if(!$this->adding and !$cat_id) return $parser->gt('no_data_found');
            switch($active_tab)
            {
                case 0:
                    $parser->addScript(SYS_BASE_URL.'main/js/popup.js');

                    $f = new tickets_models_ticket($this->objtype, $cat_id);
                    $f->id = $cat_id;
                    $f->buttonpanel = 'buttonpanelm';
                    $f->only_card = true;
                    $f->container = 'wtk_tickets_cat';
                    $form_action = (isset($_POST['form_action'])) ? $_POST['form_action'] : '';
                    switch($form_action)
                    {
                        case 'edit':
                            $f->read();
                            $s = $f->update(true);
                            if($s) $f->error_mess = $s;
                            if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                        break;
                        case 'insert':
                            $s = $f->insert(true);
                            if($s) $f->error_mess = $s;
                            else
                            {
                                if($card_onload_par) $f->onCopy($card_onload_par);
                                if($callbackfunc) print("<SCRIPT LANGUAGE=\"JavaScript\">try{".$callbackfunc.";} catch(e){}</SCRIPT>");
                                return "<SCRIPT LANGUAGE=\"JavaScript\">navigatetoid('".$f->id."');</SCRIPT>";
                            }
                        break;
                    }

                    $f->addHidden('callbackfunc', $callbackfunc);
                    $f->addHidden('cat_id', $cat_id);
                    $f->addHidden('active_tab', $active_tab);
                    $parser->addScript("<script type='text/javascript'>
                    function form_submit()
                    {
                        $('#form_dialog_".$f->container."').submit();
                    }
                    </script>");
                    $f->en_autocomplete = true;
                    if($cat_id)
                    {
                        if($this->perm['u'])
                        {
                            $f->addHidden('form_action', 'edit');
                            $f->addButton($parser->gt('save'), 'form_submit()', 'submitbutton', 'button');
                        }
                    } else
                    {
                        if($parent)  $f->setFieldVal('parent',$parent);
                        $f->setFieldAttr('parent', 'ro', 1);
                        if($this->perm['c'])
                        {
                            if($card_onload_par) $f->onBeforeCopy($card_onload_par);
                            $mastertype = (isset($_REQUEST['mastertype'])) ? $_REQUEST['mastertype'] : '';
                            $masterid = (isset($_REQUEST['masterid'])) ? $_REQUEST['masterid'] : '';
                            if($masterid)
                            {
                                $f->setFieldVal('objtype', $mastertype);
                                $f->setFieldVal('objid', $masterid);
                            }
                            $f->addHidden('form_action', 'insert');
                            $f->addButton($parser->gt('insert'), 'form_submit()', 'submitbutton', 'button');
                            $f->addButton($parser->gt('cancel'), "navigateto('last')", '', 'button');
                        }
                    }

                    return $f->showForm();
                break;
                case 1:
                    if(!$cat_id) die('');
                     // Check Rights
                    if(!$parser->getUserId()) die($parser->gt('not_perms'));
                    $perm = $parser->checkPerms('wtk_rights_tickets_com');
                    if(!$perm['r']) return '<br>'.$parser->gt('not_perms');
                    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
                    $w = new wAjaxGrid();
                    $w->edit_table_alias = 'o';

                    $w->f = new tickets_models_comments();
                    $w->caption = $parser->gt('ncomments');

                    $w->q->select('o.id',  $parser->gt('id'));
                    $w->q->select('o.creaton', $parser->gt('creaton'));
                    $w->q->lselect('u.name', $parser->gt('user'));
                    $w->q->lselect('p.name', $parser->gt('reassigned'));
                    $w->q->lselect('s.name', $parser->gt('state'));
                    //$w->q->lselect('r.name', $parser->gt('solution'));
                    $w->q->select('o.description', $parser->gt('description'), array('html' => true));

                    $w->q->from('wtk_tickets_com o');
                    $w->q->from('sys_objects u');
                    $w->q->from('sys_objects p');
                    $w->q->from('sys_objects s');
                    $w->q->from('sys_objects r');
                    $w->q->where("o.id<>'0'");
                    $w->q->where("o.userid=u.objid");
                    $w->q->where("o.newstate=s.objid");
                    $w->q->where("o.reassigned=p.objid");
                    $w->q->where("o.solution=r.objid");
                    $w->q->where("o.ticketid='".$cat_id."'");
                    $w->q->orderby('o.id DESC');
                    $w->f->extra_deleteAll_sql .= "AND ticketid='".$cat_id."' ";

                    $w->f->setFieldVal('ticketid', $cat_id);
                    $w->f->setFieldAttr('ticketid', 'refval', $parser->utils->getFieldFromSql('SELECT title FROM wtk_tickets WHERE id='.$cat_id, ''));
                    $w->f->setFieldAttr('ticketid', 'ro', true);

                    $w->addSearchField('o.description', $parser->gt('description'), 'C');

                    $w->editing = $perm['u'];
                    $w->adding = $perm['c'];
                    $w->copying = false;
                    $w->multiadding = false;
                    $w->readonlyform = true;
                    //$w->deleting = true;

                    $w->addHidden('callbackfunc', $callbackfunc);
                    if($callbackfunc) $w->oninsert_callback = $callbackfunc;
                    $w->addHidden('active_tab', $active_tab);
                    $w->addHidden('cat_id', $cat_id);

                    $w->show();

                break;
                case 2: // files
                    if(!$cat_id) die('');
                    include_once(SYS_BASE_PATH.'main/utils/fileman.class.php');
                    $w = new wcat();
                    $w->workframe = 'gridframe';
                    $w->cat_id = $cat_id;
                    $w->active_tab = $active_tab;
                    $w->objtype = 'wtk_tickets';
                    $w->startpath_org = 'userdata/modules/tickets/wtk_tickets';
                    $w->startpath = $w->startpath_org.'/';
                    $w->autocreatedir = 1;
                    $w->execute_menu  = $parser->isSuperAdmin();
                    $w->show();
                break;
                case 11: // subtickets
                    $objtype = 'wtk_tickets';
                    include_once(SYS_BASE_PATH.'ext/tickets/lib/wtk_ticketstreelist.php');
                break;
                case 17: // log
                    $objtype = 'wtk_tickets';
                    include_once(SYS_BASE_PATH.'main/system/log.php');
                break;
            }
        }
    }

    $cat = new wtablecard('wtk_tickets');
    $cat->notreeframe = true;
    $cat->navigation = true;
    $cat->navibuttons = true;
    $cat->extra_from = '';
    $cat->extra_where = '';
    $cat->adding = $perm['c'];
    $cat->deleting = $perm['d'];
    $cat->perm = $perm;

    $cat->showTable(0);

?>