<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/ckdial.class.php');
    class ckdialm extends ckdial
    {
        public function execAction()
        {
            global $parser;
            @set_time_limit(0);
            if($this->_ckboxes['tickets']['val'])
            {
                if(!$parser->conn->Execute("DELETE FROM wtk_tickets_com WHERE id>0"))
                {
                    print($parser->gt('cannotclear').' '.$parser->gtl('ncomments'));
                    exit;
                }
                if(!$parser->conn->Execute("DELETE FROM wtk_tickets WHERE id>0"))
                {
                    print($parser->gt('cannotclear').' '.$parser->gtl('tickets'));
                    exit;
                }
                $fn = SYS_BASE_PATH.'userdata/modules/tickets/wtk_tickets';
                if(file_exists($fn)) $parser->utils->removeDir($fn, true);
            }

            if($this->_ckboxes['users']['val'])
            {
                include_once(SYS_BASE_PATH.'main/objects/objects.class.php');
                $parser->enlogging = false;
                $killer = new wObjects('sys_users');

                // Clear products
                $sql = "SELECT o.objid
                        FROM sys_objects o
                        WHERE (o.objtype='wtk_t_dirs_products')
                        AND (o.objid LIKE 'tickets_product_%')";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {
                    while($row = $rs->FetchRow())
                    {
                        if(!$row[0]) continue;
                        $killer->id = $row[0];
                        $s = $killer->delete();
                        if($s)
                        {
                            print($parser->gt('cannotclear').' '.$parser->gtl('products').' '.$s);
                            exit;
                        }
                    }
                }

                // Clear users
                $sql = "SELECT o.objid
                        FROM sys_objects o
                        WHERE (o.objtype='sys_users')
                        AND (o.moduleid='tickets')";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {
                    while($row = $rs->FetchRow())
                    {
                        if(!$row[0]) continue;
                        $killer->id = $row[0];
                        $s = $killer->delete();
                        if($s)
                        {
                            print($parser->gt('cannotclear').' '.$parser->gtl('users').' '.$s);
                            exit;
                        }
                    }
                }
            }

            if(ob_get_length()) ob_clean();
            print('ok');
            exit;
        }
    }

    $f = new ckdialm();
    $f->ok_mes = $parser->gt('clearedok');
    $f->btn_caption = $parser->gt('clear');
    $f->addCkbox('tickets', $parser->gt('tickets'), 1);
    $f->addCkbox('users', $parser->gt('users'), 1);
    $f->show();


?>