<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));

    include_once(SYS_BASE_PATH.'main/classes/ckdial.class.php');
    class ckdialm extends ckdial
    {
        public function execAction()
        {
            global $parser;
            @set_time_limit(0);
            if($this->_ckboxes['tickets']['val'])
            {
                // Import components
                include_once(SYS_BASE_PATH.'main/objects/objects.class.php');
                $parser->enlogging = false;
                $f = new wObjects('wtk_t_dirs_products');

                // 1. components
                $sql = "SELECT cid, name FROM components WHERE cid>0";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {
                    while($row = $rs->FetchRow())
                    {
                        $f->setFieldNewVal('objid', 'tickets_product_'.$row[0]);
                        $f->setFieldNewVal('moduleid', 'tickets');
                        $f->setFieldNewVal('name', $row[1]);

                        $s = $f->insert();
                        if($s)
                        {
                            print($parser->gt('cannotimport').' '.$parser->gtl('components').' '.$s);
                            exit;
                        }
                    }
                }

                // 2. Critical
                $critical[0] = 'wtk_t_priorities_crit';
                $critical[1] = 'wtk_t_priorities_high';
                $critical[2] = 'wtk_t_priorities_gen';
                $critical[3] = 'wtk_t_priorities_low';

                // 3. Solutions
                $sol[0] = 'wtk_t_sols_solv';
                $sol[1] = 'wtk_t_sols_noterr';
                $sol[2] = 'wtk_t_sols_refuse';
                $sol[3] = 'wtk_t_sols_dubl';
                $sol[4] = '0';
                $sol[5] = 'wtk_t_sols_tomind';
                $sol[6] = 'wtk_t_sols_work';

                // 4. Categories
                $cat[0] = 'wtk_t_categs_err';
                $cat[1] = '0';
                $cat[2] = 'wtk_t_categs_qst';
                $cat[3] = 'wtk_t_categs_wish';

                // 5. States
                $state[0] = 'wtk_t_states_notcnfrm';
                $state[1] = 'wtk_t_states_new';
                $state[2] = 'wtk_t_states_pending';
                $state[3] = 'wtk_t_states_reopen';
                $state[4] = 'wtk_t_states_closed';
                $state[5] = 'wtk_t_states_tested';
                $state[6] = 'wtk_t_states_closed';
                $state[7] = 'wtk_t_states_chk';
                $state[8] = 'wtk_t_states_inproc';
                $state[9] = 'wtk_t_states_needinfo';



                $sql = "SELECT bid, assigned, severity, status, creation, shortdesc, priority,
                        product, component, resolution, private, cc
                        FROM bugs
                        WHERE bid>0";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {

                    include_once SYS_BASE_PATH.'main/classes/wprototype.class.php';
                    $t = new wPrototype('wtk_tickets');
                    $c = new wPrototype('wtk_tickets_com');

                    while($row = $rs->FetchRow())
                    {
                        $sql2 = "SELECT s.user, s.date, s.system, s.description
                                FROM bugdesc s
                                WHERE s.bid=".$row[0];
                        $rs2 = $parser->conn->Execute($sql2);
                        $descr = '';
                        $creatby = '0';
                        $commants = array();
                        $i = 0;
                        while($row2 = $rs2->FetchRow())
                        {
                            if(!$i)
                            {
                                $descr = iconv("WINDOWS-1251", "UTF-8", $row2[3]);
                                $creatby = $row2[0];
                            }
                            else $commants[] = array($row2[0], $row2[1], $row2[2], iconv("WINDOWS-1251", "UTF-8", $row2[3]));
                            $i++;
                        }

                        $dd = $row[4];
                        $t->setFieldNewVal('id', $row[0]);
                        $t->setFieldNewVal('creaton', substr($dd, 6, 2).'.'.substr($dd, 4, 2).'.'.substr($dd, 0, 4).' '.substr($dd, 8, 2).':'.substr($dd, 10, 2));
                        $t->setFieldNewVal('creatby', 'tickets_user_'.$creatby);
                        $t->setFieldNewVal('creatto', 'tickets_user_'.$row[1]);
                        $t->setFieldNewVal('title', iconv("WINDOWS-1251", "UTF-8", $row[5]));
                        $t->setFieldNewVal('state', $state[$row[3]]);
                        $t->setFieldNewVal('solution', ($row[9]) ? $sol[$row[9]] : 0);
                        $t->setFieldNewVal('priority', $critical[$row[6]]);
                        $t->setFieldNewVal('productid', 'tickets_product_'.$row[8]);
                        $t->setFieldNewVal('category', $cat[$row[2]]);
                        $t->setFieldNewVal('isprivate', $row[10]);
                        $t->setFieldNewVal('email', $row[11]);
                        $t->setFieldNewVal('description', strip_tags($descr));
                        $t->setFieldNewVal('comments', sizeof($commants));

                        $s = $t->insert();
                        if($s)
                        {
                            print($parser->gt('cannotimport').' '.$parser->gtl('tickets').' '.$s);
                            exit;
                        }

                        for($i = 0; $i < sizeof($commants); $i++)
                        {
                            $c->setFieldNewVal('userid', 'tickets_user_'.$commants[$i][0]);
                            $c->setFieldNewVal('description', $commants[$i][3]);
                            $c->setFieldNewVal('ticketid', $t->id);
                            $c->setFieldNewVal('creaton', $parser->utils->isoToDateformat($commants[$i][1],1));

                            $s = $c->insert();
                            if($s)
                            {
                                print($parser->gt('cannotimport').' '.$parser->gtl('comments').' '.$s);
                                exit;
                            }
                        }

                    }
                }


            }

            if($this->_ckboxes['users']['val'])
            {
                include_once(SYS_BASE_PATH.'main/objects/objects.class.php');
                $parser->enlogging = false;
                $f = new wObjects('sys_users');


                $sql = "SELECT uid, name, uname, email, passwd, access, kurator FROM users WHERE uid>0";
                $rs = $parser->conn->Execute($sql);

                if($rs and ($rs->NumRows() >= 1))
                {
                    while($row = $rs->FetchRow())
                    {
                        $f->setFieldNewVal('objid', 'tickets_user_'.$row[0]);
                        $f->setFieldNewVal('moduleid', 'tickets');
                        $f->setFieldNewVal('str1', $row[3]);
                        $f->setFieldNewVal('str2', $row[2]);
                        $f->setFieldNewVal('str3', $row[4]);
                        $f->setFieldNewVal('name', $row[1]);
                        $f->setFieldNewVal('bool1', 1);
                        $f->setFieldAttr('str3', 'encr', 0);

                        $s = $f->insert();
                        if($s)
                        {
                            print($parser->gt('cannotimport').' '.$parser->gtl('users').' '.$s);
                            exit;
                        }
                        // Add role
                        switch($row[5])
                        {
                            case 1:  $parser->addRole($f->id, 'wtk_roles_susers'); break;
                            case 10:  $parser->addRole($f->id, 'wtk_roles_exec'); break;
                            case 20:  $parser->addRole($f->id, 'wtk_roles_admin'); break;
                        }
                    }
                }
             }

            if(ob_get_length()) ob_clean();
            print('ok');
            exit;
        }
    }

    $f = new ckdialm();
    $f->ok_mes = $parser->gt('importok');
    $f->btn_caption = $parser->gt('import');
    $f->addCkbox('tickets', $parser->gt('tickets'), 0);
    $f->addCkbox('users', $parser->gt('users'), 0);
    $f->show();


?>