<?php
class tickets_models_breadcrumbs
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getCrumbs()
{
    $levels = 10;
    $res = array();
    if(!$this->parser->getUserId())
    {
        $res[] =  array('id' => 'tickets/checkuser', 'name' => $this->parser->gt('entrance'));
        return $res;
    }
    $res[0]['id'] = $this->parser->pageId;
    $p = $this->parser->utils->getFieldsFromSql("SELECT parent, name_".$this->parser->lang_suff.", ref5 FROM sys_objects WHERE objid = '".$this->parser->pageId."'", array('0', ''), 'num');
    $res[0]['name'] = $p[1];
    $parent = $p[0];
    while(($parent != 'tickets/home') && ($parent != 'tickets/more') && ($parent != '0'))
    {
        $p = $this->parser->utils->getFieldsFromSql("SELECT parent, name_".$this->parser->lang_suff.", ref5 FROM sys_objects WHERE objid = '".$parent."'", array('0', ''), 'num');

        $id = ($p[2]) ? $p[2] : $parent;

        $ma = explode('/', $id);
        $controller = '';
        if(sizeof($ma) >= 2)
        {
            for($i = 0; $i < sizeof($ma); $i++)
            {
                if(!$i) $controller = $ma[$i].'/controllers';
                    else $controller .= '/'.$ma[$i];
            }
            $file = SYS_BASE_PATH.'ext/'.$controller.'.php';
            if(!file_exists($file)) $id = '';
        }
        $res[] = array('id' => $id, 'name' => $p[1]);
        $parent = $p[0];
    	$levels--;
    	if(!$levels) break;
    }
    $id = $this->parser->gs('sys_start_page');
/*
    $res[] = array('id' => $id, 'name' =>  $this->parser->utils->getFieldFromSql("SELECT name_".$this->parser->lang_suff.
                    " FROM sys_objects WHERE objid = '".$id."'", ''));
*/
    //$res[] = array('id' => $id, 'name' =>  $this->parser->config['site_name']);
    return $res;
}

}

?>