<?php
class tickets_models_reports_createrate
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getReport()
{
    $parser = $this->parser;


    ob_start();
    $u = $parser->utils->getUserInfo();
    $action =  (isset($_REQUEST["action"])) ? $_REQUEST["action"] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;
    $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : 0;

    include_once(SYS_BASE_PATH.'main/classes/chart.class.php');
    $w = new wChart('vbar', 800, 400);
    $w->title = $this->parser->utils->getFieldFromSql("SELECT name_".$this->parser->lang_suff." FROM sys_objects WHERE objid='".$this->parser->pageId."'", '');

    switch($action)
    {
        case 'verbar';
            $fltr = ($filter_period) ? " AND (o.creaton ".$parser->utils->getPeriod($filter_period, true).")" : '';
            if($filter_state) $fltr .= "  AND (o.state IN('".$filter_state."'))";
            $rs = $parser->conn->Execute("SELECT u.name_".$parser->lang_suff.", COUNT(*) AS CNT
            FROM sys_objects u, wtk_tickets o
            WHERE (u.objid=o.creatby)
            AND (o.creatby<>'0') ".$fltr."
            GROUP BY u.name_".$parser->lang_suff."
            ORDER BY CNT DESC, u.name_".$parser->lang_suff);
            $i = 0;
            while($row = $rs->FetchRow())
            {
                $w->add($row[0],$row[1]);
                $i++;
                if($i>50) break;
            }
            $w->show();
            $output = ob_get_contents();
            ob_end_clean();
            return $output;
        break;
    }

    $w->popup_script = true;
    $pars = array();
    $pars['name'] = 'filter_state';
    $pars['emptyval'] = 0;
    $pars['tree_btn'] = 0;
    $pars['width'] = 150;
    $pars['emptyrefval'] = $parser->gt('allstates');
    $pars['onchange'] = 'document.form_hiddens.submit()';
    $pars['val'] = $filter_state;
    $pars['refval'] = (!$filter_state) ? $parser->gt('allstates') : $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$filter_state."'", '');;
    $pars['objtype'] = 'wtk_t_dirs_states';
    $w->addCell($parser->utils->finder($pars));

    $pars = array();
    $pars['onchange'] = 'document.form_hiddens.submit()';
    $pars['name'] = 'filter_period';
    $pars['val'] = $filter_period;
    $w->addCell($parser->utils->periodMenu($pars));

    print($w->getCells());
    print("<hr />");
    print("<img src=\"".$parser->makeUrl($parser->pageId, 'action=verbar&filter_period='.$filter_period.'&filter_state='.$filter_state)."\"><br />");

    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}

}

?>