<div class="cb_whitebg">
<?php

    $en_edit = false;
    if(!$parser->getUserId()) $parser->redirect('tickets/checkuser', 'loginhomeid='.$parser->pageId);

    $perm = $parser->checkPerms('wtk_rights_tickets');
    if(!$perm['r']) return $parser->gt('not_perms');
    include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $det = new wAjaxGrid();

    $master_id =  (isset($_POST["master_id"])) ? $_POST["master_id"] : 0;


    $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 0;
    $projectid = (isset($_REQUEST['projectid'])) ? $_REQUEST['projectid'] : 0;
    $objtype = (isset($_REQUEST['objtype'])) ? $_REQUEST['objtype'] : 0;
    $objid = (isset($_REQUEST['objid'])) ? $_REQUEST['objid'] : 0;

    $w->f = new tickets_models_ticket();

    $w->edit_table_alias = 'o';
    $w->delete_all = false;
    $w->func_on_empty = false;
    $u = $parser->utils->getUserInfo();

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.creaton', $parser->gt('createdon'));
    $w->q->select('o.title', $parser->gt('name'), array('func' => 'open_doccard'));
    $w->q->lselect('p.name AS pname', $parser->gt('priority'));
    $w->q->lselect('pr.name AS prname', $parser->gt('product'));
    $comments_col = $w->q->select('o.comments', $parser->gt('scomments'), array('hide' => 1));
    $lastposttime_col = $w->q->select('o.lastposttime', $parser->gt('lastposttime'), array('hide' => 1));
    $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
    $w->q->select('o.updateon', $parser->gt('updateon'), array('hide' => 1));
    $GLOBALS['comments_col'] = $comments_col;
    $GLOBALS['lastposttime_col'] = $lastposttime_col;

    $w->q->from('wtk_tickets o');
    $w->q->from('sys_objects u');
    $w->q->from('sys_objects uc');
    $w->q->from('sys_objects c');
    $w->q->from('sys_objects s');
    $w->q->from('sys_objects p');
    $w->q->from('sys_objects r');
    $w->q->from('sys_objects pr');
    $w->q->where("o.id<>'0'");
    $w->q->where("o.creatto=u.objid");
    $w->q->where("o.creatby=c.objid");
    $w->q->where("o.state=s.objid");
    $w->q->where("o.priority=p.objid");
    $w->q->where("o.solution=r.objid");
    $w->q->where("o.productid=pr.objid");
    $w->q->where('o.lastposter=uc.objid');
    $w->q->orderby('o.updateon DESC');
    $w->q->orderby('o.id DESC');

    if($objtype and $objid)
    {
        $filter_color = 0;
        $filter_period = 0;
        $w->q->where("o.objtype='".$objtype."'");
        $w->q->where("o.objid='".$objid."'");
        $w->f->extra_deleteAll_sql .= "AND objtype='".$objtype."' AND objid='".$objid."' ";
        $w->f->setFieldVal('objtype', $objtype);
        $w->f->setFieldVal('objid', $objid);
    }

    if($projectid)
    {
        $filter_color = 0;
        $filter_period = 0;
        $w->f->extra_deleteAll_sql .= "AND projectid=".$projectid." ";
        $w->q->where('o.projectid='.$projectid);
        $w->f->setFieldVal('projectid', $projectid);
        //$w->f->setFieldAttr('projectid', 'refval', $parser->utils->getFieldFromSql('SELECT title FROM wcrmp_projects WHERE id='.$projectid, ''));
        $w->f->setFieldAttr('projectid', 'ro', true);
    }
    $itisauser = false;
    if(!$u['super'])
    {
        if($parser->checkRoles(array('wtk_roles_admin', 'wtk_roles_exec', 'sys_role_admin')))
        {
            $itisauser = true;
            $w->q->where("(o.isprivate=0) OR (o.creatby='".$u['id'].
                "') OR (o.creatto='".$u['id'].
                "') OR (o.monitoring='".$u['id'].
                "') OR ((o.creatby<>'".$u['id']."') AND (c.ref1 IN(".$u['subdepartments'].")) AND (c.ref2 IN(".$u['subpositions'].")))");
        } else $w->q->where("(o.isprivate=0) OR (o.creatby='".$u['id']."')");  // if not executor, administrator or monitoring can see public and own privates
    }

    if($filter_color)
    {
        $w->q->where("o.color='".$filter_color."'");
        $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
        $w->f->setFieldVal('color', $filter_color);
    }
    if($filter_period)
    {
         $per = $parser->utils->getPeriod($filter_period, true);
         $w->q->where("o.creaton ".$per);
         $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
    }

    $ed_coms = false;
    switch($type)
    {
        case 'formeopen':
            $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $w->q->where("o.creatto='".$u['id']."'");
            $w->q->where("o.state<>'wtk_t_states_closed'");
            $ed_coms = true;
        break;
        case 'icontrolopen':
            $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $w->q->where("o.monitoring='".$u['id']."'");
            $w->q->where("o.state<>'wtk_t_states_closed'");
            $ed_coms = true;
        break;
        case 'myopen':
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $en_edit = true;
            $w->q->where("o.creatby='".$u['id']."'");
            $w->q->where("o.state<>'wtk_t_states_closed'");
            $ed_coms = true;
        break;
        case 'myall':
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $en_edit = true;
            $w->q->where("o.creatby='".$u['id']."'");
        break;
        case 'solved':
            $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->lselect('r.name AS rname', $parser->gt('solution'));
            $w->q->where("o.state='wtk_t_states_closed'");
        break;
        case 'search':
            $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
            $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
            $w->q->lselect('s.name AS sname', $parser->gt('state'));
            $w->q->lselect('r.name AS rname', $parser->gt('solution'));
        break;
    }

    $w->q->select('uc.name AS ucname', $parser->gt('lastpost'), array('lang' => 1, 'func' => 'showdetail', 'calc' => 'form_lastcomm'));
    function form_lastcomm($rs,$i,$v,$obj)
    {
        global $parser, $comments_col, $lastposttime_col;
        if(!$rs->fields[$comments_col]) return '';
        return  $rs->UserTimeStamp($rs->fields[$lastposttime_col], $parser->gs('sys_user_dateformat').' H:i').' '.$v;
    }

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_period';
    $pars['val'] = $filter_period;
    if(!$projectid and !$objtype and !$objid)
    $w->addCell($parser->utils->periodMenu($pars));

    $pars = array();
    $pars['onchange'] = $w->container."_postAction('',0)";
    $pars['name'] = 'filter_color';
    $pars['val'] = $filter_color;
    $pars['colored'] = true;
    $pars['options'] = array($parser->gt('allcolors'));
    if(!$projectid and !$objtype and !$objid)
    $w->addCell($parser->utils->dropdownMenu($pars));

    $w->addSearchField('o.id', $parser->gt('id'), 'I');
    $w->addSearchField('o.creaton', $parser->gt('creaton'), 'D');
    $w->addSearchField('o.duedate', $parser->gt('duedate'), 'D');
    $w->addSearchField('o.updateon', $parser->gt('updateon'), 'D');
    $w->addSearchField('o.title', $parser->gt('name'), 'C');
    $w->addSearchField('o.notes', $parser->gt('notes'), 'C');
    $w->addSearchField('o.description', $parser->gt('description'), 'C');
    $w->addSearchField('o.conclusion', $parser->gt('conclusion'), 'C');
    $w->addSearchField('o.email', $parser->gt('email'), 'C');
    $w->addSearchField('o.partid', $parser->gt('partid'), 'C');
    if($itisauser)
    {
        $w->addSearchField('o.creatby', $parser->gt('creatby'), 'sys_users');
        $w->addSearchField('o.creatto', $parser->gt('creatto'), 'sys_users');
        $w->addSearchField('o.monitoring', $parser->gt('monitoring'), 'sys_users');
    }
    $w->addSearchField('o.solution', $parser->gt('solution'), 'wtk_t_dirs_sols');
    $w->addSearchField('o.priority', $parser->gt('priority'), 'wtk_t_dirs_priorities');
    $w->addSearchField('o.state', $parser->gt('state'), 'wtk_t_dirs_states');
    $w->addSearchField('o.product', $parser->gt('product'), 'wtk_t_dirs_products');
    $w->addSearchField('o.source', $parser->gt('source'), 'wtk_t_dirs_srcs');
    $w->addSearchField('o.category', $parser->gt('category'), 'wtk_t_dirs_categs');
    $w->addSearchField('o.comments', $parser->gt('comments'), 'I');
    //$w->addSearchField('o.objtype', $parser->gt('objtype'), 'sys_objtypes');
    //$w->addSearchField('o.objid', $parser->gt('objid'), 'I');

    $w->editing = $perm['u'];
    $w->adding = $perm['c'] && $en_edit;
    $w->copying = $perm['c'] && $en_edit;
    $w->deleting = $perm['d'] && $en_edit;
    $w->multiselect = false;
    $w->en_mainmenu =false;

    $w->addHidden('projectid', $projectid);
    $w->addHidden('objtype', $objtype);
    $w->addHidden('objid', $objid);
    $w->cardurl = $parser->makeUrl('wtk_tickets_card');

    $src = "<script type=\"text/javascript\">
    function open_doccard(id, i, idx)
    {
        openWinc('".$parser->makeUrl('wtk_tickets_card')."', 'callbackfunc=self.opener.global_".$w->container.".reReadRow(' + idx + ')&objid=' + id);
    }
    function showdetail(id, i, idx)
    {
        global_".$w->container.".showsubgrid(id, i, idx);
    }
    </script>";
    $parser->addScript($src);
    $w->subgrid = 'detailgrid';
    $w->pagelen = 10;

    $w->show();

    $action = '';
    switch($startaction)
    {
        case 'ticketadding': $action = 'global_'.$w->container.'.adding()'; break;
        case 'ticketsearching': $action = 'global_'.$w->container.'.Search()'; break;
        case 'ticketshow':
            $ticketid= (isset($_REQUEST['ticketid'])) ? $_REQUEST['ticketid'] : 0;
            if(!$ticketid  or ($ticketid == 'undefined')) break;
            $action = 'global_'.$w->container.'.editing('.$ticketid.')';
        break;
    }

    if($action)
    {
        $script = "<script type='text/javascript'>
    	$(document).ready(function() {
    	".$action.";
    	});
        </script>\n
        ";
        $parser->addScript($script);
    }

    if($master_id)
    {
        $tstr = mb_substr(strip_tags($parser->utils->getFieldFromSql('SELECT description FROM wtk_tickets WHERE id='.$master_id, '')), 0, 512, $parser->config['charset']);
        //$tstr = str_replace(",", " ", $tstr);
        $det->addRow($tstr,'','text');
    }

    $det->caption = $parser->gt('ncomments');
    $det->container = 'detailgrid';
    $det->visible = false;
    $det->pagelen = 10;

    if($ed_coms)
    {
        $det->adding = $perm['u'];
        $det->en_mainmenu = false;
        $det->multiadding = false;
        $det->copying = false;
        $det->f = new tickets_models_comments();
        $det->f->setFieldVal('ticketid', $master_id);
    }

    $det->q->select('o.id', $parser->gt('id'));
    $det->q->select('o.creaton', $parser->gt('creaton'));
    $det->q->lselect('w.name AS cname', $parser->gt('user'));
    $det->q->lselect('p.name AS pname', $parser->gt('reassigned'));
    $det->q->select('o.description',  $parser->gt('description'), array('html' => true));
    $det->q->from('wtk_tickets_com o');
    $det->q->from('sys_objects w');
    $det->q->from('sys_objects p');
    $det->q->where("o.id>0");
    $det->q->where("o.userid=w.objid");
    $det->q->where("o.reassigned=p.objid");
    $det->q->where("o.ticketid='".$master_id."'");
    $det->q->orderby('o.id DESC');

    // Print the grid
    $det->show();

?>
</div>