<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
  <title><?php print($metatitle) ?></title>
  <meta http-equiv="Content-Type" content="text/html; charset=<?php print($charset) ?>" />
  <meta name="keywords" content="<?php print($metakeywords) ?>" />
  <meta name="description" content="<?php print($metadescription) ?>" />
<base href="<?php print($basurl) ?>" ></base>
<?php if(file_exists(SYS_BASE_PATH.'ext/'.$moduleid.'/views/template/css/style.css')) { ?>
<link rel="stylesheet" href="<?php print(SYS_BASE_URL) ?>ext/<?php print($moduleid) ?>/views/template/css/style.css" type="text/css" />
<?php } print($headers) ?>
</head>
<body>
<div id="main">

    <!-- Header -->
    <div id="header">
        <div class="topnav">
            <?php print($topmenu) ?>
        </div>
            <!-- Menu -->
        		<div class="topnav2 mnav_blue">
                    <div id="menu-box" class="cleaning-box">
                        <?php
                         print($menu);
                        ?>
                    </div>
        		</div>
            <!-- Menu end -->
            <div class="header-in_2">
                <!-- Your website name  -->
                <div class="mainlogo"><a href="<?php print($this->makeUrl($this->gs('sys_start_page'))) ?>"><img src="<?php print(SYS_BASE_URL) ?>main/images/logo/bird64.png"  width="52" height="52" /></a>&nbsp;</div>
                <!-- Your website name end -->
                <div id="breadcrumb">
                    <?php print($breadcrumbs) ?>
                </div>

                <!-- TOP USER -->
                <div class="top_user">
					<?php if($userinfo['id']) { ?>
    					<span>
        					<?php if($userinfo['avatar']) { ?>
        					<img src="<?php print(SYS_BASE_URL) ?><?php print($userinfo['avatar']) ?>" width="40" height="40">
        			        <?php } ?>
    					</span>
    					<b><?php print($userinfo['name']) ?></b>
					<?php } ?>
                </div>
                <!-- TOP USER END -->

                <!-- Search form -->
					<?php if($searchform) { ?>
                            <div class="top_search">

                                <?php print($searchform) ?>
                            </div>
					<?php } ?>
                <!-- Search end -->
                <!-- TOP LANGS -->
                <div id="site-langs">
                    <form name="languages" action="" method="get">
                    <form name="languages_form" id="languages_form" action="<?php print($parser->makeUrl()); ?>" method="get">
                        <span>
                        <select name="lang" onchange="this.form.submit();" size="1">
                            <?php foreach($languages as $opt) {
                                print("<option value=\"".$opt['id']."\"".(($opt['selected']) ? ' selected' : '' ).">".$opt['title']."</option>\n");
                            } ?>
                        </select>
                        </span>
                        <input name="action" type="hidden" value="setLanguage">
                        <input name="pageid" type="hidden" value="<?php print($parser->pageId); ?>">
                    </form>

                </div>
                <!-- TOP LANGS END -->
            </div>
    </div>
    <!-- Header end -->


    <div id="skip-menu"></div>

    <div id="content">

        <!-- Content box with white background and gray border -->
        <div id="content-box">

            <?php print($content) ?>

			<div class="cleaner">&nbsp;</div>
			<!-- Right column end -->
		</div>
		<!-- Content box with white background and gray border end -->

    	<!-- Footer -->
    	<div class="footer">
    		<div class="footer-left"><?php print($footer) ?> Copyright  © <a href="http://www.wad-er.com/">Wad-er</a>, 2010-2015</div>
    		<div class="footer-right">{^s^}, {^t^}, {^p^}</div><br clear="all">
    	</div>
    	<!-- Footer end -->

	</div>

</div>

</body>
</html>