<?php
        // Check Rights
        if(!$parser->getUserId()) die($parser->gt('not_perms'));
        $perm = $parser->checkPerms('wtk_rights_tickets');
        if(!$perm['r']) die($parser->gt('not_perms'));
        include_once(SYS_BASE_PATH.'main/classes/wajaxgrid.class.php');
        $w = new wAjaxGrid();
        $w->func_on_empty = false;

        $det = new wAjaxGrid();

        $master_id =  (isset($_POST["master_id"])) ? $_POST["master_id"] : 0;
        $projectid = (isset($_REQUEST['projectid'])) ? $_REQUEST['projectid'] : 0;

        $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : '';
        $filter_isprivate = (isset($_REQUEST['filter_isprivate'])) ? $_REQUEST['filter_isprivate'] : '';
        $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
        $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 1;
        //include_once(SYS_BASE_PATH.'ext/tickets/classes/wtk_tickets.class.php');
        $w->f = new tickets_models_ticket();
        $w->edit_table_alias = 'o';

        $u = $parser->utils->getUserInfo();

        //$w->caption = $parser->gt('wtk_tickets', __FILE__);
        $w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wtk_tickets'", '');

        $w->q->select('o.id',  $parser->gt('id'));
        $w->q->select('o.creaton', $parser->gt('createdon'));
        $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
        $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
        $w->q->select('o.title', $parser->gt('name'), array('edit' => $perm['u']));
        $w->q->lselect('s.name AS sname', $parser->gt('state'));
        $w->q->lselect('p.name AS pname', $parser->gt('priority'));
        $w->q->lselect('r.name AS rname', $parser->gt('solution'));
        $w->q->lselect('pr.name AS prname', $parser->gt('product'));
        $w->q->select('o.comments', $parser->gt('scomments'), array('func' => 'showdetail'));

        $w->q->from('wtk_tickets o');
        $w->q->from('sys_objects u');
        $w->q->from('sys_objects c');
        $w->q->from('sys_objects s');
        $w->q->from('sys_objects p');
        $w->q->from('sys_objects r');
        $w->q->from('sys_objects pr');
        $w->q->where("o.id<>'0'");
        $w->q->where("o.creatto=u.objid");
        $w->q->where("o.creatby=c.objid");
        $w->q->where("o.state=s.objid");
        $w->q->where("o.priority=p.objid");
        $w->q->where("o.solution=r.objid");
        $w->q->where("o.productid=pr.objid");
        $w->q->orderby('o.id DESC');


        if($projectid)
        {
            $filter_isprivate = 0;
            $filter_state = 0;
            $filter_color = 0;
            $filter_period = 0;
            $w->q->where('o.projectid='.$projectid);
            $w->f->setFieldVal('projectid', $projectid);
            //$w->f->setFieldAttr('projectid', 'refval', $parser->utils->getFieldFromSql('SELECT title FROM wcrmp_projects WHERE id='.$projectid, ''));
            $w->f->setFieldAttr('projectid', 'ro', true);
        }

        $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
        if($filter_color)
        {
            $w->q->where("o.color='".$filter_color."'");
            $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
            $w->f->setFieldVal('color', $filter_color);
        }
        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.creaton ".$per);
             $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
        }
        switch($filter_isprivate)
        {
            case 1:	 $w->q->where("o.creatto='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 2:	 $w->q->where("o.creatto='".$u['id']."'");
            break;
            case 3:	 $w->q->where("o.monitoring='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 4:	 $w->q->where("o.monitoring='".$u['id']."'");
            break;
            case 5:	 $w->q->where("o.creatby='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 6:	 $w->q->where("o.creatby='".$u['id']."'");
            break;
        }


        if($filter_state)
        {
            $mfilter_state = $parser->utils->addQuots($filter_state);
            $w->q->where("o.state IN(".$mfilter_state.")");
            $w->f->extra_deleteAll_sql .= "AND state IN(".$mfilter_state.") ";
            $w->f->setFieldVal('state', $filter_state);
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        if(!$projectid)
        $w->addCell($parser->utils->periodMenu($pars));

        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_isprivate';
        $pars['val'] = $filter_isprivate;
        $pars['options'] = array($parser->gt('all'),
                                 $parser->gt('formeunresolved'),
                                 $parser->gt('formeall'),
                                 $parser->gt('icontrolunresolved'),
                                 $parser->gt('icontrol'),
                                 $parser->gt('mysunresolved'),
                                 $parser->gt('mys'),
                                 );
        if(!$projectid)
        $w->addCell($parser->utils->dropdownMenu($pars));

        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_color';
        $pars['val'] = $filter_color;
        $pars['colored'] = true;
        $pars['options'] = array($parser->gt('allcolors'));
        //$pars['sql'] = 'SELECT objid, name_'.$parser->lang_suff." FROM sys_objects WHERE objtype='sys_interface_colors' ORDER BY name_".$parser->lang_suff;
        if(!$projectid)
        $w->addCell($parser->utils->dropdownMenu($pars));


        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_state';
        $pars['emptyval'] = 0;
        $pars['tree_btn'] = 0;
        $pars['emptyrefval'] = $parser->gt('allstates');
        $pars['val'] = $filter_state;
        $pars['objtype'] = 'wtk_t_dirs_states';
        if(!$projectid)
        $w->addCell($parser->utils->finder($pars));

        $w->addSearchField('o.creaton', $parser->gt('creaton'), 'D');
        $w->addSearchField('o.duedate', $parser->gt('duedate'), 'D');
        $w->addSearchField('o.updateon', $parser->gt('updateon'), 'D');
        $w->addSearchField('o.title', $parser->gt('name'), 'C');
        $w->addSearchField('o.notes', $parser->gt('notes'), 'C');
        $w->addSearchField('o.description', $parser->gt('description'), 'C');
        $w->addSearchField('o.conclusion', $parser->gt('conclusion'), 'C');
        $w->addSearchField('o.email', $parser->gt('email'), 'C');
        $w->addSearchField('o.partid', $parser->gt('partid'), 'C');
        $w->addSearchField('o.creatby', $parser->gt('creatby'), 'sys_users');
        $w->addSearchField('o.creatto', $parser->gt('creatto'), 'sys_users');
        $w->addSearchField('o.monitoring', $parser->gt('monitoring'), 'sys_users');
        $w->addSearchField('o.solution', $parser->gt('solution'), 'wcrmp_t_dirs_sols');
        $w->addSearchField('o.priority', $parser->gt('priority'), 'wcrmp_t_dirs_priorities');
        $w->addSearchField('o.state', $parser->gt('state'), 'wcrmp_t_dirs_states');
        $w->addSearchField('o.product', $parser->gt('product'), 'wcrmp_t_dirs_products');
        $w->addSearchField('o.source', $parser->gt('source'), 'wcrmp_t_dirs_srcs');
        $w->addSearchField('o.category', $parser->gt('category'), 'wcrmp_t_dirs_categs');
        $w->addSearchField('o.comments', $parser->gt('comments'), 'I');

        $w->editing = $perm['u'];
        $w->adding = $perm['c'];
        $w->copying = $perm['c'];
        $w->deleting = $perm['d'];
        $w->multiselect = $perm['d'];

        $w->addHidden('projectid', $projectid);

        $w->cardurl = $parser->makeUrl('wtk_tickets_card');

        $src = "<script type=\"text/javascript\">
        function showdetail(id, i, idx)
        {
            global_".$w->container.".showsubgrid(id, i, idx);
        }
        </script>";
        $parser->addScript($src);
        $w->subgrid = 'detailgrid';
        $w->show();

        $det->caption = $parser->gt('ncomments');
        $det->container = 'detailgrid';
        $det->visible = false;
        $det->pagelen = 10;

        $det->q->select('o.id', $parser->gt('id'));
        $det->q->select('o.creaton', $parser->gt('creaton'));
        $det->q->lselect('w.name AS cname', $parser->gt('user'));
        $det->q->lselect('p.name AS pname', $parser->gt('reassigned'));
        $det->q->select('o.description',  $parser->gt('description'));
        $det->q->from('wtk_tickets_com o');
        $det->q->from('sys_objects w');
        $det->q->from('sys_objects p');
        $det->q->where("o.id>0");
        $det->q->where("o.userid=w.objid");
        $det->q->where("o.reassigned=p.objid");
        $det->q->where("o.ticketid='".$master_id."'");
        $det->q->orderby('o.id DESC');

        // Print the grid
        $det->show();

?>