<?php
    // Check Rights
    if(!$parser->getUserId()) die($parser->gt('not_perms'));
    $perm = $parser->checkPerms('wtk_rights_tickets');
    if(!$perm['r']) die($parser->gt('not_perms'));

    $active_tab =  (isset($active_tab)) ? $active_tab : '0';
    $cat_id =  (isset($cat_id)) ? $cat_id : '0';
    $callbackfunc =  (isset($callbackfunc)) ? $callbackfunc : '';
    $objtype = (isset($objtype)) ? $objtype :  ((isset($_REQUEST["objtype"])) ? $_REQUEST["objtype"] : '0');
    $objid = ($cat_id) ? $cat_id :  ((isset($_REQUEST["objid"])) ? $_REQUEST["objid"] : '0');

    $filter_state = (isset($_REQUEST['filter_state'])) ? $_REQUEST['filter_state'] : '';
    $filter_color = (isset($_REQUEST['filter_color'])) ? $_REQUEST['filter_color'] : '';
    $filter_period = (isset($_REQUEST['filter_period'])) ? $_REQUEST['filter_period'] : 0;
    include_once(SYS_BASE_PATH.'main/classes/wajaxtreelist.class.php');
    $w = new wAjaxTreeList();
    //$w->caption = $parser->utils->getFieldFromSql('SELECT name_'.$parser->lang_suff." FROM sys_objtypes WHERE objtype='wcrmp_tickets'", '');
    $w->caption = $parser->gt('tickets');
    $w->f = new tickets_models_ticket();

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.title', $parser->gt('name'), array());
    $w->q->select('o.isfolder',  $parser->gt('isfolder'));
    $w->q->select('o.parent',  $parser->gt('parent'));

    $w->q->select('o.id',  $parser->gt('id'));
    $w->q->select('o.creaton', $parser->gt('createdon'));
    $w->q->lselect('c.name AS cname', $parser->gt('creatby'));
    $w->q->lselect('u.name AS uname', $parser->gt('creatto'));
    $w->q->lselect('s.name AS sname', $parser->gt('state'));
    //$w->q->lselect('p.name AS pname', $parser->gt('priority'));
    //$w->q->lselect('r.name AS rname', $parser->gt('solution'));
    //$w->q->lselect('pr.name AS prname', $parser->gt('product'));
    $w->q->select('o.comments', $parser->gt('scomments'));

    $w->q->from('wtk_tickets o');
    $w->q->from('sys_objects u');
    $w->q->from('sys_objects c');
    $w->q->from('sys_objects s');
    $w->q->from('sys_objects p');
    $w->q->from('sys_objects r');
    $w->q->from('sys_objects pr');
    $w->q->where("o.id>0");
    $w->q->where("o.creatto=u.objid");
    $w->q->where("o.creatby=c.objid");
    $w->q->where("o.state=s.objid");
    $w->q->where("o.priority=p.objid");
    $w->q->where("o.solution=r.objid");
    $w->q->where("o.productid=pr.objid");
    $w->q->where("o.parent=:parent:");
    $w->q->orderby('o.id DESC');


    $w->rowclass_col = $w->q->select('o.color', $parser->gt('color'), array('hide' => 1));
    if(!$objid)
    {

        if($filter_color)
        {
            $w->q->where("o.color='".$filter_color."'");
            $w->f->extra_deleteAll_sql .= "AND color='".$filter_color."' ";
            $w->f->setFieldVal('color', $filter_color);
        }
        if($filter_period)
        {
             $per = $parser->utils->getPeriod($filter_period, true);
             $w->q->where("o.creaton ".$per);
             $w->f->extra_deleteAll_sql .= "AND (creaton ".$per.")";
        }
        switch($filter_state)
        {
            case 1:         $w->q->where("o.creatto='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 2:         $w->q->where("o.creatto='".$u['id']."'");
            break;
            case 3:         $w->q->where("o.monitoring='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 4:         $w->q->where("o.monitoring='".$u['id']."'");
            break;
            case 5:         $w->q->where("o.creatby='".$u['id']."'");
                     $w->q->where("o.state NOT IN('wtk_t_states_closed')");
            break;
            case 6:         $w->q->where("o.creatby='".$u['id']."'");
            break;
        }
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_period';
        $pars['val'] = $filter_period;
        $w->addCell($parser->utils->periodMenu($pars));

        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_color';
        $pars['val'] = $filter_color;
        $pars['colored'] = true;
        $pars['options'] = array($parser->gt('allcolors'));
        $w->addCell($parser->utils->dropdownMenu($pars));

        $w->popup_script = true;
        $pars = array();
        $pars['onchange'] = $w->container."_postAction('',0)";
        $pars['name'] = 'filter_state';
        $pars['width'] = 150;
        $pars['val'] = $filter_state;
        $pars['options'] = array($parser->gt('all'),
                                 $parser->gt('formeunresolved'),
                                 $parser->gt('formeall'),
                                 $parser->gt('icontrolunresolved'),
                                 $parser->gt('icontrol'),
                                 $parser->gt('mysunresolved'),
                                 $parser->gt('mys'),
                                 );
        $w->addCell($parser->utils->finder($pars));
    } else
    {
        $w->startid = $objid;
    }

    $w->editing = $perm['u'];
    $w->adding = $perm['c'];
    $w->copying = $perm['c'];
    $w->deleting = $perm['d'];

    $w->addHidden('objtype', $objtype);
    $w->addHidden('objid', $objid);
    $w->addHidden('active_tab', $active_tab);
    $w->addHidden('cat_id', $cat_id);
    $w->addHidden('callbackfunc', $callbackfunc);

    $w->cardurl = $parser->makeUrl('wtk_tickets_card');

    $w->show();
?>