<?php

class tickets_models_lastcomments
{

protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getList()
{
    $userid = $this->parser->getUserId();

    $this->parser->addScript(SYS_BASE_URL.'main/js/popup.js');
    $src = "<script type=\"text/javascript\">
    function open_ticketcard(id)
    {
        openWinc('".$this->parser->makeUrl('wtk_tickets_card')."', 'objid=' + id);
    }
    </script>";
    $this->parser->addScript($src);

    include_once SYS_BASE_PATH.'main/classes/wsql.class.php';
    $q = new wSql();
    $q->select('o.id');
    $q->select('o.ticketid');
    $q->select('t.title');
    $q->select('o.creaton');
    $q->lselect('c.name AS cname');
    $q->lselect('u.name AS uname');
    $q->lselect('p.name AS pname');
    $q->lselect('s.name AS sname');
    $q->lselect('r.name AS rname');
    $q->select('o.description');
    $q->select('u.avatar');

    $q->from('wtk_tickets_com o');
    $q->from('wtk_tickets t');
    $q->from('sys_objects u');
    $q->from('sys_objects p');
    $q->from('sys_objects s');
    $q->from('sys_objects r');
    $q->from('sys_objects c');

    $q->where("o.id<>'0'");
    $q->where("t.creatby=c.objid");
    $q->where("o.userid=u.objid");
    $q->where("o.newstate=s.objid");
    $q->where("o.reassigned=p.objid");
    $q->where("o.solution=r.objid");
    $q->where('o.ticketid=t.id');
    $q->where("(t.creatby='".$userid."') OR (t.creatto='".$userid."') OR (t.monitoring='".$userid."')");
    $q->where("o.userid<>'".$userid."'");
    $q->where('o.creaton '.$this->parser->utils->getPeriod(1, true));

    $q->orderby('o.id DESC');


    //$this->parser->toFile($sql);
    $rs = $this->parser->conn->SelectLimit($q->getSql(), 15);
    $data = array();
    $i = 0;
    while($row = $rs->FetchRow())
    {
        $data[] = array('id' => $row[0],
                        'ticketid' => $row[1],
                        'title' => $row[2],
                        'creaton' => $rs->UserTimeStamp($row[3], $this->parser->gs('sys_user_dateformat').' H:i'),
                        'cname' => $row[4],
                        'uname' => $row[5],
                        'pname' => $row[6],
                        'sname' => $row[7],
                        'rname' => $row[8],
                        'avatar' => ($row[10]) ? SYS_BASE_URL.$row[10] : SYS_BASE_URL.'main/images/icons/avatar.png',
                        'classname' => ($i % 2) ? 'comment_odd' : 'comment_even',
                        'description' => strip_tags($row[9])
        );
        $i++;
    }
    return $data;
}

}

?>