<?php
class tickets_models_menu
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getMenu()
{
    $m = new docMainMenu();
    $m->startId = 'tickets/home';
    $m->level = 3;
    $m->outerid = 'nav';
    $m->en_folder = false;
    $m->parentClass = 'top_parent';
    $m->parentRowTpl = 'sys_chunks_parentRow';
    return $m->show(false);
}

}

include_once(SYS_BASE_PATH.'main/classes/ulmenu.class.php');
class docMainMenu extends ulMenu
{

protected function onBeforeShowItem($row)
{
    global $parser;

    //$row['name'] = $row['name'];
    $userid = $parser->getUserId();
    $u = $parser->utils->getUserInfo();

    $cond = '';
    if(!$u['super']) $cond .= " AND ((p.isprivate=0) OR (p.creatby='".$u['id'].
              "') OR (p.creatto='".$u['id'].
              "') OR (p.monitoring='".$u['id'].
              "') OR ((p.creatby<>'".$u['id']."')
              AND (c.ref1 IN(".$u['subdepartments']."))
              AND (c.ref2 IN(".$u['subpositions'].")))) ";
    $sql = "SELECT COUNT(p.id)
            FROM wtk_tickets p, sys_objects c
            WHERE (p.creatby=c.objid)
            AND (p.id > 0)
            ".$cond;
    switch($row['objid'])
    {
        case 'tickets/checkuser':  if($userid) return false; break;
        case 'tickets/ticketlist/formeopen':
            $n = $parser->utils->getFieldFromSql($sql." AND (p.creatto='".$u['id']."' AND (p.state<>'wtk_t_states_closed'))", 0);
            if(!$n) return $row;
            $row['name'] .= ' ('.$n.')';
            //$row['name'] .= " <sup><small>".$n."</small></sup>";
        break;
        case 'tickets/ticketlist/myopen':
            $n = $parser->utils->getFieldFromSql($sql." AND (p.creatby='".$u['id']."' AND (p.state<>'wtk_t_states_closed'))", 0);
            if(!$n) return $row;
            $row['name'] .= ' ('.$n.')';
        break;
        case 'tickets/ticketlist/icontrolopen':
            $n = $parser->utils->getFieldFromSql($sql." AND (p.monitoring='".$u['id']."' AND (p.state<>'wtk_t_states_closed'))", 0);
            if(!$n) return $row;
            $row['name'] .= ' ('.$n.')';
        break;
        case 'tickets/messages':
            $n = $parser->utils->getFieldFromSql("SELECT COUNT(*) FROM sys_intmail
                                              WHERE touserid='".$u['id']."'
                                              AND (wasread=0)", 0);
            if(!$n) return $row;
            $row['name'] .= ' ('.$n.')';
        break;
    }
    return $row;
}

}

?>