<?php
class tickets_models_reports_dinamic
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getReport()
{
    $parser = $this->parser;
    ob_start();
    $u = $parser->utils->getUserInfo();
    $action =  (isset($_REQUEST["action"])) ? $_REQUEST["action"] : '';

    $filter_user = (isset($_REQUEST['filter_user'])) ? $_REQUEST['filter_user'] : 0;
    $month = (isset($_REQUEST['month'])) ? $_REQUEST['month'] : 0;
    $ext = ($filter_user) ? "AND (s.creatby IN('".$filter_user."'))" : '';

    include_once(SYS_BASE_PATH.'main/classes/chart.class.php');
    $w = new wChart('line',800, 400);
    $w->title = $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$parser->pageId."'", '');

    switch($action)
    {
        case 'linechart';
            $year = adodb_date('Y');
            $today = $parser->utils->toDate();
            $start = $parser->utils->toDate($parser->utils->shiftDates($today, -30, 'd'));
            $finish = $today;
            if(($month > 0) and ($month < 12))
            {
                    $start = $parser->utils->toDate(adodb_mktime(0, 0, 0, $month, 1, $year));
                    $finish = adodb_mktime(0, 0, 0, $month + 1, 1, $year);
                    $finish = $parser->utils->toDate($parser->utils->shiftDates($finish , -1, 'd'));
            }

            for($i = 0; $i < 31; $i++)
            {
                $start = $parser->utils->toDate($parser->utils->shiftDates($start , 1, 'd'));
                $end = $parser->utils->toDate($parser->utils->shiftDates($start , 1, 'd'));
                $end = $parser->utils->toDate($parser->utils->shiftDates($end , -1, 'mi'), 1);
                if($parser->utils->strToDate($start) > $parser->utils->strToDate($finish)) break;
                $val = $parser->utils->getFieldFromSql("SELECT COUNT(*)
                                                        FROM wtk_tickets s
                                                        WHERE (s.id>0) ".$ext."
                                                        AND s.creaton BETWEEN ".
                                                        $parser->conn->DBDate($parser->utils->dateToISOformat($start)).
                                                        " AND ".$parser->conn->DBDate($parser->utils->dateToISOformat($end, 1)), 0);
                $w->add($start, $val);
            }

            $w->show();
            $output = ob_get_contents();
            ob_end_clean();
            return $output;
        break;
    }

    $pars['name'] = 'month';
    $pars['onchange'] = 'document.form_hiddens.submit()';
    $pars['val'] = $month;
    $pars['options'] = array($parser->gt('lastdays','',30),
                             $parser->gt('january'),
                             $parser->gt('february'),
                             $parser->gt('march'),
                             $parser->gt('april'),
                             $parser->gt('may'),
                             $parser->gt('june'),
                             $parser->gt('july'),
                             $parser->gt('auguest'),
                             $parser->gt('september'),
                             $parser->gt('october'),
                             $parser->gt('november'),
                             $parser->gt('december')
    );
    $w->addCell($parser->utils->dropdownMenu($pars));

    $w->popup_script = true;
    $pars = array();
    $pars['name'] = 'filter_user';
    $pars['emptyval'] = 0;
    $pars['tree_btn'] = 0;
    $pars['width'] = 150;
    $pars['emptyrefval'] = $parser->gt('allusers');
    $pars['onchange'] = 'document.form_hiddens.submit()';
    $pars['val'] = $filter_user;
    $pars['refval'] = (!$filter_user) ? $parser->gt('allusers') : $parser->utils->getFieldFromSql("SELECT name_".$parser->lang_suff." FROM sys_objects WHERE objid='".$filter_user."'", '');;
    $pars['objtype'] = 'sys_users';
    $w->addCell($parser->utils->finder($pars));

    print($w->getCells());
    print("<hr />");
    print("<img src=\"".$parser->makeUrl($parser->pageId, 'action=linechart&filter_user='.$filter_user.'&month='.$month)."\"><br />");

    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}

}

?>