<?php
class tickets_models_reports_ownerstate
{
protected $parser;

public function __construct($parser)
{
    $this->parser = $parser;
}

public function getReport()
{
    $parser = $this->parser;

    $master_id =  (isset($_POST["master_id"])) ? $_POST["master_id"] : 0;
    $master_col =  (isset($_POST["master_col"])) ? $_POST["master_col"] : 0;
    $master_row =  (isset($_POST["master_row"])) ? $_POST["master_row"] : 0;

    $u = $parser->utils->getUserInfo();

    include_once('main/classes/wajaxgrid.class.php');
    $w = new wAjaxGrid();
    $det = new wAjaxGrid();

    $w->pagelen = 20;
    $shift = 0;

    $w->q->select('u.objid', $parser->gt('id'));
    $w->q->lselect('u.name', $parser->gt('owner'));

    $rs = $parser->conn->Execute("SELECT DISTINCT s.objid, s.name_".$parser->lang_suff."
    FROM sys_objects s, wtk_tickets t
    WHERE (s.objtype='wtk_t_dirs_states')
    AND (s.objid<>'0')
    AND (s.objid=t.state)
    AND (s.objid<>'wtk_t_states_closed')
    ORDER BY s.name_".$parser->lang_suff);
    $i = 0;
    while($row = $rs->FetchRow())
    {
        if($i == (int)$master_col - 2) $det->q->where("o.state='".$row[0]."'");
        $w->q->select("SUM(CASE WHEN o.state='".$row[0]."' THEN 1 ELSE 0 END) AS ".$row[0]."_QTY", $row[1], array('dig' => 0, 'func' => 'showdetail'));
        $i++;
    }
    $w->q->select("SUM(1) AS AllTIME_QTY", $parser->gt('allstates'), array('dig' => 0, 'func' => 'showdetail'));
    $w->q->from('wtk_tickets o');
    $w->q->from('sys_objects u');
    $w->q->where("o.creatto=u.objid");
    $w->q->where("u.objid<>'0'");
    $w->q->where("o.state<>'wtk_t_states_closed'");
    if(!$u['super']) $w->q->where("(o.isprivate=0) OR (o.creatby='".$u['id'].
              "') OR (o.creatto='".$u['id'].
              "') OR (o.monitoring='".$u['id'].
              "') OR ((o.creatby<>'".$u['id']."') AND (u.ref1 IN(".$u['subdepartments'].")) AND (u.ref2 IN(".$u['subpositions'].")))");
    $w->q->groupby('u.objid');
    $w->q->lgroupby('u.name');
    $w->q->lorderby('u.name');
    //$w->debug = 1;
    //$w->addSearchField('l.createdon', $parser->gt('date'),'D');
    $src = "<script type=\"text/javascript\">
    function showdetail(id, i, idx)
    {
        global_".$w->container.".showsubgrid(id, i, idx);
    }
    </script>";
    $parser->addScript($src);

    $w->subgrid = 'detailgrid';

    ob_start();
    $w->show();

    $det->caption = $parser->gt('tickets');
    $det->container = 'detailgrid';
    $det->visible = false;
    $det->pagelen = 10;

    $det->q->select('o.id',  $parser->gt('id'));
    $det->q->select('o.creaton', $parser->gt('createdon'));
    //$det->q->lselect('u.name AS uname', $parser->gt('creatto'));
    $det->q->lselect('c.name AS cname', $parser->gt('creatby'));
    $det->q->select('o.title', $parser->gt('name'), array('func' => 'open_doccard'));
    $det->q->lselect('p.name AS pname', $parser->gt('priority'));
    $det->q->lselect('pr.name AS prname', $parser->gt('product'));
    //$det->q->lselect('s.name AS sname', $parser->gt('state'));
    $det->q->select('o.comments', $parser->gt('scomments'));
    $det->rowclass_col = $det->q->select('o.color', $parser->gt('color'), array('hide' => 1));

    $det->q->from('wtk_tickets o');
    $det->q->from('sys_objects u');
    $det->q->from('sys_objects c');
    $det->q->from('sys_objects s');
    $det->q->from('sys_objects p');
    $det->q->from('sys_objects r');
    $det->q->from('sys_objects pr');
    $det->q->where("o.id<>'0'");
    $det->q->where("o.creatto=u.objid");
    $det->q->where("o.creatto='".$master_id."'");
    $det->q->where("o.creatby=c.objid");
    $det->q->where("o.state=s.objid");
    $det->q->where("o.priority=p.objid");
    $det->q->where("o.solution=r.objid");
    $det->q->where("o.productid=pr.objid");
    $det->q->where("o.state<>'wtk_t_states_closed'");
    if(!$u['super']) $det->q->where("(o.isprivate=0) OR (o.creatby='".$u['id'].
              "') OR (o.creatto='".$u['id'].
              "') OR (o.monitoring='".$u['id'].
              "') OR ((o.creatby<>'".$u['id']."') AND (c.ref1 IN(".$u['subdepartments'].")) AND (c.ref2 IN(".$u['subpositions'].")))");
    $det->q->orderby('o.id DESC');
    $det->cardurl = $parser->makeUrl('wtk_tickets_card');
    $det->editing = 1;
    $src = "<script type=\"text/javascript\">
    function open_doccard(id, i, idx)
    {
        openWinc('".$parser->makeUrl('wtk_tickets_card')."', 'callbackfunc=self.opener.global_".$det->container.".reReadRow(' + idx + ')&objid=' + id);
    }
    </script>";
    $parser->addScript($src);

    // Print the grid
    $det->show();


    $output = ob_get_contents();
    ob_end_clean();
    return $output;
}

}

?>